//
// Register Declarations for Microchip 12CR509A Processor
//
//
// This header file was automatically generated by:
//
//	inc2h.pl V1.4
//
//	Copyright (c) 2002, Kevin L. Pauba, All Rights Reserved
//
//	SDCC is licensed under the GNU Public license (GPL) v2.  Note that
//	this license covers the code to the compiler and other executables,
//	but explicitly does not cover any code or objects generated by sdcc.
//	We have not yet decided on a license for the run time libraries, but
//	it will not put any requirements on code linked against it. See:
// 
//	http://www.gnu.org/copyleft/gpl/html
//
//	See http://sdcc.sourceforge.net/ for the latest information on sdcc.
//
// 
#ifndef P12CR509A_H
#define P12CR509A_H

#ifndef BIT_AT
#define BIT_AT(base,bitno) sbit at ((base<<3)+bitno)
#endif

//
// Register addresses.
//
#define INDF_ADDR	0x0000
#define TMR0_ADDR	0x0001
#define PCL_ADDR	0x0002
#define STATUS_ADDR	0x0003
#define FSR_ADDR	0x0004
#define OSCCAL_ADDR	0x0005
#define GPIO_ADDR	0x0006

//
// Memory organization.
//
#pragma maxram 0x3F


#pragma memmap INDF_ADDR INDF_ADDR SFR 0x000	// INDF
#pragma memmap TMR0_ADDR TMR0_ADDR SFR 0x000	// TMR0
#pragma memmap PCL_ADDR PCL_ADDR SFR 0x000	// PCL
#pragma memmap STATUS_ADDR STATUS_ADDR SFR 0x000	// STATUS
#pragma memmap FSR_ADDR FSR_ADDR SFR 0x000	// FSR
#pragma memmap OSCCAL_ADDR OSCCAL_ADDR SFR 0x000	// OSCCAL
#pragma memmap GPIO_ADDR GPIO_ADDR SFR 0x000	// GPIO


// 	LIST
// P12C509A.INC  Standard Header File, Version 1.00    Microchip Technology, Inc.
// 	NOLIST

// This header file defines configurations, registers, and other useful bits of
// information for the PIC12C509A and PIC12CR509A microcontrollers.  These names are taken to match 
// the data sheets as closely as possible.  

// Note that the processor must be selected before this file is 
// included.  The processor may be selected the following ways:

//       1. Command line switch:
//               C:\ MPASM MYFILE.ASM /P12C509A    or
//               C:\ MPASM MYFILE.ASM /P12CR509A
//       2. LIST directive in the source file
//               LIST   P=12C509A    or
//               LIST   P=12CR509A
//       3. Processor Type entry in the MPASM full-screen interface

//==========================================================================
//
//	   Revision History
//
//==========================================================================

//Rev:   Date:    Reason:
//1.00   05/28/97 Initial Release
//1.10   06/12/02 Verification now includes the PIC12CR509A (pas)

//==========================================================================
//
//       Verify Processor
//
//==========================================================================

//        IFNDEF __12C509A
//	IFNDEF __12CR509A
//            MESSG "Processor-header file mismatch.  Verify selected processor."
//         ENDIF
// 	ENDIF

//==========================================================================
//
//       Register Definitions
//
//==========================================================================

#define W                    0x0000
#define F                    0x0001

//----- Register Files -----------------------------------------------------

data at INDF_ADDR volatile char        INDF;
sfr  at TMR0_ADDR                      TMR0;
data at PCL_ADDR volatile char         PCL;
sfr  at STATUS_ADDR                    STATUS;
sfr  at FSR_ADDR                       FSR;
sfr  at OSCCAL_ADDR                    OSCCAL;
sfr  at GPIO_ADDR                      GPIO;

//----- STATUS Bits --------------------------------------------------------

BIT_AT(STATUS_ADDR,7)	GPWUF;
BIT_AT(STATUS_ADDR,5)	PA0;
BIT_AT(STATUS_ADDR,4)	NOT_TO;
BIT_AT(STATUS_ADDR,3)	NOT_PD;
BIT_AT(STATUS_ADDR,2)	Z;
BIT_AT(STATUS_ADDR,1)	DC;
BIT_AT(STATUS_ADDR,0)	C;

//----- OPTION Bits --------------------------------------------------------

BIT_AT(OPTION_REG_ADDR,7)	NOT_GPWU;
BIT_AT(OPTION_REG_ADDR,6)	NOT_GPPU;
BIT_AT(OPTION_REG_ADDR,5)	T0CS;
BIT_AT(OPTION_REG_ADDR,4)	T0SE;
BIT_AT(OPTION_REG_ADDR,3)	PSA;
BIT_AT(OPTION_REG_ADDR,2)	PS2;
BIT_AT(OPTION_REG_ADDR,1)	PS1;
BIT_AT(OPTION_REG_ADDR,0)	PS0;

//----- OSCCAL Bits --------------------------------------------------------

BIT_AT(OSCCAL_ADDR,7)	CAL5;
BIT_AT(OSCCAL_ADDR,6)	CAL4;
BIT_AT(OSCCAL_ADDR,5)	CAL3;
BIT_AT(OSCCAL_ADDR,4)	CAL2;
BIT_AT(OSCCAL_ADDR,3)	OSCFST;
BIT_AT(OSCCAL_ADDR,3)	CAL1;
BIT_AT(OSCCAL_ADDR,2)	OSCSLW;
BIT_AT(OSCCAL_ADDR,2)	CAL0;

//==========================================================================
//
//       RAM Definition
//
//==========================================================================

//         __MAXRAM H'3F'

//==========================================================================
//
//       Configuration Bits
//
//==========================================================================

#define _MCLRE_ON            0x0FFF
#define _MCLRE_OFF           0x0FEF
#define _CP_ON               0x0FF7
#define _CP_OFF              0x0FFF
#define _WDT_ON              0x0FFF
#define _WDT_OFF             0x0FFB
#define _LP_OSC              0x0FFC
#define _XT_OSC              0x0FFD
#define _IntRC_OSC           0x0FFE
#define _ExtRC_OSC           0x0FFF

// 	LIST
#endif
