//
// Register Declarations for Microchip 16C620 Processor
//
//
// This header file was automatically generated by:
//
//	inc2h.pl V1.4
//
//	Copyright (c) 2002, Kevin L. Pauba, All Rights Reserved
//
//	SDCC is licensed under the GNU Public license (GPL) v2.  Note that
//	this license covers the code to the compiler and other executables,
//	but explicitly does not cover any code or objects generated by sdcc.
//	We have not yet decided on a license for the run time libraries, but
//	it will not put any requirements on code linked against it. See:
// 
//	http://www.gnu.org/copyleft/gpl/html
//
//	See http://sdcc.sourceforge.net/ for the latest information on sdcc.
//
// 
#ifndef P16C620_H
#define P16C620_H

#ifndef BIT_AT
#define BIT_AT(base,bitno) sbit at ((base<<3)+bitno)
#endif

//
// Register addresses.
//
#define INDF_ADDR	0x0000
#define TMR0_ADDR	0x0001
#define PCL_ADDR	0x0002
#define STATUS_ADDR	0x0003
#define FSR_ADDR	0x0004
#define PORTA_ADDR	0x0005
#define PORTB_ADDR	0x0006
#define PCLATH_ADDR	0x000A
#define INTCON_ADDR	0x000B
#define PIR1_ADDR	0x000C
#define CMCON_ADDR	0x001F
#define OPTION_REG_ADDR	0x0081
#define TRISA_ADDR	0x0085
#define TRISB_ADDR	0x0086
#define PIE1_ADDR	0x008C
#define PCON_ADDR	0x008E
#define VRCON_ADDR	0x009F

//
// Memory organization.
//
#pragma maxram 0x09F


#pragma memmap INDF_ADDR INDF_ADDR SFR 0x000	// INDF
#pragma memmap TMR0_ADDR TMR0_ADDR SFR 0x000	// TMR0
#pragma memmap PCL_ADDR PCL_ADDR SFR 0x000	// PCL
#pragma memmap STATUS_ADDR STATUS_ADDR SFR 0x000	// STATUS
#pragma memmap FSR_ADDR FSR_ADDR SFR 0x000	// FSR
#pragma memmap PORTA_ADDR PORTA_ADDR SFR 0x000	// PORTA
#pragma memmap PORTB_ADDR PORTB_ADDR SFR 0x000	// PORTB
#pragma memmap PCLATH_ADDR PCLATH_ADDR SFR 0x000	// PCLATH
#pragma memmap INTCON_ADDR INTCON_ADDR SFR 0x000	// INTCON
#pragma memmap PIR1_ADDR PIR1_ADDR SFR 0x000	// PIR1
#pragma memmap CMCON_ADDR CMCON_ADDR SFR 0x000	// CMCON
#pragma memmap OPTION_REG_ADDR OPTION_REG_ADDR SFR 0x000	// OPTION_REG
#pragma memmap TRISA_ADDR TRISA_ADDR SFR 0x000	// TRISA
#pragma memmap TRISB_ADDR TRISB_ADDR SFR 0x000	// TRISB
#pragma memmap PIE1_ADDR PIE1_ADDR SFR 0x000	// PIE1
#pragma memmap PCON_ADDR PCON_ADDR SFR 0x000	// PCON
#pragma memmap VRCON_ADDR VRCON_ADDR SFR 0x000	// VRCON


//         LIST
// P16C620.INC  Standard Header File, Version 1.01    Microchip Technology, Inc.
//         NOLIST

// This header file defines configurations, registers, and other useful bits of
// information for the PIC16C620 microcontroller.  These names are taken to match 
// the data sheets as closely as possible.  

// Note that the processor must be selected before this file is 
// included.  The processor may be selected the following ways:

//       1. Command line switch:
//               C:\ MPASM MYFILE.ASM /PIC16C620
//       2. LIST directive in the source file
//               LIST   P=PIC16C620
//       3. Processor Type entry in the MPASM full-screen interface

//==========================================================================
//
//       Revision History
//
//==========================================================================

//Rev:   Date:    Reason:

//1.01   11/28/95 Added NOT_BOR to match revised datasheet
//1.00   10/31/95 Initial Release

//==========================================================================
//
//       Verify Processor
//
//==========================================================================

//        IFNDEF __16C620
//            MESSG "Processor-header file mismatch.  Verify selected processor."
//         ENDIF

//==========================================================================
//
//       Register Definitions
//
//==========================================================================

#define W                    0x0000
#define F                    0x0001

//----- Register Files------------------------------------------------------

data at INDF_ADDR volatile char        INDF;
sfr  at TMR0_ADDR                      TMR0;
data at PCL_ADDR volatile char         PCL;
sfr  at STATUS_ADDR                    STATUS;
sfr  at FSR_ADDR                       FSR;
sfr  at PORTA_ADDR                     PORTA;
sfr  at PORTB_ADDR                     PORTB;
sfr  at PCLATH_ADDR                    PCLATH;
sfr  at INTCON_ADDR                    INTCON;
sfr  at PIR1_ADDR                      PIR1;
sfr  at CMCON_ADDR                     CMCON;

sfr  at OPTION_REG_ADDR                OPTION_REG;
sfr  at TRISA_ADDR                     TRISA;
sfr  at TRISB_ADDR                     TRISB;
sfr  at PIE1_ADDR                      PIE1;
sfr  at PCON_ADDR                      PCON;
sfr  at VRCON_ADDR                     VRCON;

//----- STATUS Bits --------------------------------------------------------

BIT_AT(STATUS_ADDR,7)	IRP;
BIT_AT(STATUS_ADDR,6)	RP1;
BIT_AT(STATUS_ADDR,5)	RP0;
BIT_AT(STATUS_ADDR,4)	NOT_TO;
BIT_AT(STATUS_ADDR,3)	NOT_PD;
BIT_AT(STATUS_ADDR,2)	Z;
BIT_AT(STATUS_ADDR,1)	DC;
BIT_AT(STATUS_ADDR,0)	C;

//----- INTCON Bits --------------------------------------------------------

BIT_AT(INTCON_ADDR,7)	GIE;
BIT_AT(INTCON_ADDR,6)	PEIE;
BIT_AT(INTCON_ADDR,5)	T0IE;
BIT_AT(INTCON_ADDR,4)	INTE;
BIT_AT(INTCON_ADDR,3)	RBIE;
BIT_AT(INTCON_ADDR,2)	T0IF;
BIT_AT(INTCON_ADDR,1)	INTF;
BIT_AT(INTCON_ADDR,0)	RBIF;

//----- PIR1 Bits ----------------------------------------------------------

BIT_AT(PIR1_ADDR,6)	CMIF;

//----- CMCON Bits ---------------------------------------------------------

BIT_AT(CMCON_ADDR,7)	C2OUT;
BIT_AT(CMCON_ADDR,6)	C1OUT;
BIT_AT(CMCON_ADDR,3)	CIS;
BIT_AT(CMCON_ADDR,2)	CM2;
BIT_AT(CMCON_ADDR,1)	CM1;
BIT_AT(CMCON_ADDR,0)	CM0;

//----- OPTION Bits --------------------------------------------------------

BIT_AT(OPTION_REG_ADDR,7)	NOT_RBPU;
BIT_AT(OPTION_REG_ADDR,6)	INTEDG;
BIT_AT(OPTION_REG_ADDR,5)	T0CS;
BIT_AT(OPTION_REG_ADDR,4)	T0SE;
BIT_AT(OPTION_REG_ADDR,3)	PSA;
BIT_AT(OPTION_REG_ADDR,2)	PS2;
BIT_AT(OPTION_REG_ADDR,1)	PS1;
BIT_AT(OPTION_REG_ADDR,0)	PS0;

//----- PIE1 Bits ----------------------------------------------------------

BIT_AT(PIE1_ADDR,6)	CMIE;

//----- PCON Bits ----------------------------------------------------------

BIT_AT(PCON_ADDR,1)	NOT_POR;
BIT_AT(PCON_ADDR,0)	NOT_BO;
BIT_AT(PCON_ADDR,0)	NOT_BOR;

//----- VRCON Bits ---------------------------------------------------------

BIT_AT(VRCON_ADDR,7)	VREN;
BIT_AT(VRCON_ADDR,6)	VROE;
BIT_AT(VRCON_ADDR,5)	VRR;
BIT_AT(VRCON_ADDR,3)	VR3;
BIT_AT(VRCON_ADDR,2)	VR2;
BIT_AT(VRCON_ADDR,1)	VR1;
BIT_AT(VRCON_ADDR,0)	VR0;

//==========================================================================
//
//       RAM Definition
//
//==========================================================================

//         __MAXRAM H'09F'
//         __BADRAM H'07'-H'09', H'0D'-H'1E', H'70'-H'7F'
//         __BADRAM H'87'-H'89', H'8D', H'8F'-H'9E'

//==========================================================================
//
//       Configuration Bits
//
//==========================================================================

#define _BODEN_ON            0x3FFF
#define _BODEN_OFF           0x3FBF
#define _CP_ON               0x00CF
#define _CP_OFF              0x3FFF
#define _PWRTE_OFF           0x3FFF
#define _PWRTE_ON            0x3FF7
#define _WDT_ON              0x3FFF
#define _WDT_OFF             0x3FFB
#define _LP_OSC              0x3FFC
#define _XT_OSC              0x3FFD
#define _HS_OSC              0x3FFE
#define _RC_OSC              0x3FFF

//         LIST
#endif
