//
// Register Declarations for Microchip 16C716 Processor
//
//
// This header file was automatically generated by:
//
//	inc2h.pl V1.4
//
//	Copyright (c) 2002, Kevin L. Pauba, All Rights Reserved
//
//	SDCC is licensed under the GNU Public license (GPL) v2.  Note that
//	this license covers the code to the compiler and other executables,
//	but explicitly does not cover any code or objects generated by sdcc.
//	We have not yet decided on a license for the run time libraries, but
//	it will not put any requirements on code linked against it. See:
// 
//	http://www.gnu.org/copyleft/gpl/html
//
//	See http://sdcc.sourceforge.net/ for the latest information on sdcc.
//
// 
#ifndef P16C716_H
#define P16C716_H

#ifndef BIT_AT
#define BIT_AT(base,bitno) sbit at ((base<<3)+bitno)
#endif

//
// Register addresses.
//
#define INDF_ADDR	0x0000
#define TMR0_ADDR	0x0001
#define PCL_ADDR	0x0002
#define STATUS_ADDR	0x0003
#define FSR_ADDR	0x0004
#define PORTA_ADDR	0x0005
#define PORTB_ADDR	0x0006
#define DATACCP_ADDR	0x0007
#define PCLATH_ADDR	0x000A
#define INTCON_ADDR	0x000B
#define PIR1_ADDR	0x000C
#define TMR1L_ADDR	0x000E
#define TMR1H_ADDR	0x000F
#define T1CON_ADDR	0x0010
#define TMR2_ADDR	0x0011
#define T2CON_ADDR	0x0012
#define CCPR1L_ADDR	0x0015
#define CCPR1H_ADDR	0x0016
#define CCP1CON_ADDR	0x0017
#define ADRES_ADDR	0x001E
#define ADCON0_ADDR	0x001F
#define OPTION_REG_ADDR	0x0081
#define TRISA_ADDR	0x0085
#define TRISB_ADDR	0x0086
#define TRISCCP_ADDR	0x0087
#define PIE1_ADDR	0x008C
#define PCON_ADDR	0x008E
#define PR2_ADDR	0x0092
#define ADCON1_ADDR	0x009F

//
// Memory organization.
//
#pragma maxram 0xBF


#pragma memmap INDF_ADDR INDF_ADDR SFR 0x000	// INDF
#pragma memmap TMR0_ADDR TMR0_ADDR SFR 0x000	// TMR0
#pragma memmap PCL_ADDR PCL_ADDR SFR 0x000	// PCL
#pragma memmap STATUS_ADDR STATUS_ADDR SFR 0x000	// STATUS
#pragma memmap FSR_ADDR FSR_ADDR SFR 0x000	// FSR
#pragma memmap PORTA_ADDR PORTA_ADDR SFR 0x000	// PORTA
#pragma memmap PORTB_ADDR PORTB_ADDR SFR 0x000	// PORTB
#pragma memmap DATACCP_ADDR DATACCP_ADDR SFR 0x000	// DATACCP
#pragma memmap PCLATH_ADDR PCLATH_ADDR SFR 0x000	// PCLATH
#pragma memmap INTCON_ADDR INTCON_ADDR SFR 0x000	// INTCON
#pragma memmap PIR1_ADDR PIR1_ADDR SFR 0x000	// PIR1
#pragma memmap TMR1L_ADDR TMR1L_ADDR SFR 0x000	// TMR1L
#pragma memmap TMR1H_ADDR TMR1H_ADDR SFR 0x000	// TMR1H
#pragma memmap T1CON_ADDR T1CON_ADDR SFR 0x000	// T1CON
#pragma memmap TMR2_ADDR TMR2_ADDR SFR 0x000	// TMR2
#pragma memmap T2CON_ADDR T2CON_ADDR SFR 0x000	// T2CON
#pragma memmap CCPR1L_ADDR CCPR1L_ADDR SFR 0x000	// CCPR1L
#pragma memmap CCPR1H_ADDR CCPR1H_ADDR SFR 0x000	// CCPR1H
#pragma memmap CCP1CON_ADDR CCP1CON_ADDR SFR 0x000	// CCP1CON
#pragma memmap ADRES_ADDR ADRES_ADDR SFR 0x000	// ADRES
#pragma memmap ADCON0_ADDR ADCON0_ADDR SFR 0x000	// ADCON0
#pragma memmap OPTION_REG_ADDR OPTION_REG_ADDR SFR 0x000	// OPTION_REG
#pragma memmap TRISA_ADDR TRISA_ADDR SFR 0x000	// TRISA
#pragma memmap TRISB_ADDR TRISB_ADDR SFR 0x000	// TRISB
#pragma memmap TRISCCP_ADDR TRISCCP_ADDR SFR 0x000	// TRISCCP
#pragma memmap PIE1_ADDR PIE1_ADDR SFR 0x000	// PIE1
#pragma memmap PCON_ADDR PCON_ADDR SFR 0x000	// PCON
#pragma memmap PR2_ADDR PR2_ADDR SFR 0x000	// PR2
#pragma memmap ADCON1_ADDR ADCON1_ADDR SFR 0x000	// ADCON1


//         LIST
// P16C716.INC  Standard Header File, Version 1.01    Microchip Technology, Inc.
//         NOLIST

// This header file defines configurations, registers, and other useful bits of
// information for the PIC16C716 microcontroller.  These names are taken to match 
// the data sheets as closely as possible.  

// Note that the processor must be selected before this file is 
// included.  The processor may be selected the following ways:

//       1. Command line switch:
//               C:\ MPASM MYFILE.ASM /PIC16C716
//       2. LIST directive in the source file
//               LIST   P=PIC16C716
//       3. Processor Type entry in the MPASM full-screen interface

//==========================================================================
//
//       Revision History
//
//==========================================================================

//Rev:      Date:     Reason:

//1.00   25 Jan 1999  Initial Release

//==========================================================================
//
//       Verify Processor
//
//==========================================================================

//        IFNDEF __16C716
//            MESSG "Processor-header file mismatch.  Verify selected processor."
//         ENDIF

//==========================================================================
//
//       Register Definitions
//
//==========================================================================

#define W                    0x0000
#define F                    0x0001

//----- Register Files------------------------------------------------------

data at INDF_ADDR volatile char        INDF;
sfr  at TMR0_ADDR                      TMR0;
data at PCL_ADDR volatile char         PCL;
sfr  at STATUS_ADDR                    STATUS;
sfr  at FSR_ADDR                       FSR;
sfr  at PORTA_ADDR                     PORTA;
sfr  at PORTB_ADDR                     PORTB;
sfr  at DATACCP_ADDR                   DATACCP;
sfr  at PCLATH_ADDR                    PCLATH;
sfr  at INTCON_ADDR                    INTCON;
sfr  at PIR1_ADDR                      PIR1;
sfr  at TMR1L_ADDR                     TMR1L;
sfr  at TMR1H_ADDR                     TMR1H;
sfr  at T1CON_ADDR                     T1CON;
sfr  at TMR2_ADDR                      TMR2;
sfr  at T2CON_ADDR                     T2CON;
sfr  at CCPR1L_ADDR                    CCPR1L;
sfr  at CCPR1H_ADDR                    CCPR1H;
sfr  at CCP1CON_ADDR                   CCP1CON;
sfr  at ADRES_ADDR                     ADRES;
sfr  at ADCON0_ADDR                    ADCON0;

sfr  at OPTION_REG_ADDR                OPTION_REG;
sfr  at TRISA_ADDR                     TRISA;
sfr  at TRISB_ADDR                     TRISB;
sfr  at TRISCCP_ADDR                   TRISCCP;
sfr  at PIE1_ADDR                      PIE1;
sfr  at PCON_ADDR                      PCON;
sfr  at PR2_ADDR                       PR2;
sfr  at ADCON1_ADDR                    ADCON1;

//----- STATUS Bits --------------------------------------------------------

BIT_AT(STATUS_ADDR,7)	IRP;
BIT_AT(STATUS_ADDR,6)	RP1;
BIT_AT(STATUS_ADDR,5)	RP0;
BIT_AT(STATUS_ADDR,4)	NOT_TO;
BIT_AT(STATUS_ADDR,3)	NOT_PD;
BIT_AT(STATUS_ADDR,2)	Z;
BIT_AT(STATUS_ADDR,1)	DC;
BIT_AT(STATUS_ADDR,0)	C;

//----- DATACCP Bits --------------------------------------------------------

BIT_AT(DATACCP_ADDR,2)	DCCP;
BIT_AT(DATACCP_ADDR,0)	DT1CK;

//----- INTCON Bits --------------------------------------------------------

BIT_AT(INTCON_ADDR,7)	GIE;
BIT_AT(INTCON_ADDR,6)	PEIE;
BIT_AT(INTCON_ADDR,5)	T0IE;
BIT_AT(INTCON_ADDR,4)	INTE;
BIT_AT(INTCON_ADDR,3)	RBIE;
BIT_AT(INTCON_ADDR,2)	T0IF;
BIT_AT(INTCON_ADDR,1)	INTF;
BIT_AT(INTCON_ADDR,0)	RBIF;

//----- PIR1 Bits ----------------------------------------------------------

BIT_AT(PIR1_ADDR,6)	ADIF;
BIT_AT(PIR1_ADDR,2)	CCP1IF;
BIT_AT(PIR1_ADDR,1)	TMR2IF;
BIT_AT(PIR1_ADDR,0)	TMR1IF;

//----- T1CON Bits ---------------------------------------------------------

BIT_AT(T1CON_ADDR,5)	T1CKPS1;
BIT_AT(T1CON_ADDR,4)	T1CKPS0;
BIT_AT(T1CON_ADDR,3)	T1OSCEN;
BIT_AT(T1CON_ADDR,2)	T1SYNC;
BIT_AT(T1CON_ADDR,2)	NOT_T1SYNC;
BIT_AT(T1CON_ADDR,1)	TMR1CS;
BIT_AT(T1CON_ADDR,0)	TMR1ON;

//----- T2CON Bits ---------------------------------------------------------

BIT_AT(T2CON_ADDR,6)	TOUTPS3;
BIT_AT(T2CON_ADDR,5)	TOUTPS2;
BIT_AT(T2CON_ADDR,4)	TOUTPS1;
BIT_AT(T2CON_ADDR,3)	TOUTPS0;
BIT_AT(T2CON_ADDR,2)	TMR2ON;
BIT_AT(T2CON_ADDR,1)	T2CKPS1;
BIT_AT(T2CON_ADDR,0)	T2CKPS0;


//----- CCP1CON Bits -------------------------------------------------------

BIT_AT(CCP1CON_ADDR,5)	DC1B1;
BIT_AT(CCP1CON_ADDR,4)	DC1B0;
BIT_AT(CCP1CON_ADDR,3)	CCP1M3;
BIT_AT(CCP1CON_ADDR,2)	CCP1M2;
BIT_AT(CCP1CON_ADDR,1)	CCP1M1;
BIT_AT(CCP1CON_ADDR,0)	CCP1M0;

//----- ADCON0 Bits --------------------------------------------------------

BIT_AT(ADCON0_ADDR,7)	ADCS1;
BIT_AT(ADCON0_ADDR,6)	ADCS0;
BIT_AT(ADCON0_ADDR,5)	CHS2;
BIT_AT(ADCON0_ADDR,4)	CHS1;
BIT_AT(ADCON0_ADDR,3)	CHS0;
BIT_AT(ADCON0_ADDR,2)	GO;
BIT_AT(ADCON0_ADDR,2)	NOT_DONE;
BIT_AT(ADCON0_ADDR,2)	GO_DONE;
BIT_AT(ADCON0_ADDR,0)	ADON;

//----- OPTION Bits --------------------------------------------------------

BIT_AT(OPTION_REG_ADDR,7)	NOT_RBPU;
BIT_AT(OPTION_REG_ADDR,6)	INTEDG;
BIT_AT(OPTION_REG_ADDR,5)	T0CS;
BIT_AT(OPTION_REG_ADDR,4)	T0SE;
BIT_AT(OPTION_REG_ADDR,3)	PSA;
BIT_AT(OPTION_REG_ADDR,2)	PS2;
BIT_AT(OPTION_REG_ADDR,1)	PS1;
BIT_AT(OPTION_REG_ADDR,0)	PS0;

//----- TRISCCP Bits --------------------------------------------------------

BIT_AT(TRISCCP_ADDR,2)	TCCP;
BIT_AT(TRISCCP_ADDR,0)	TT1CK;

//----- PIE1 Bits ----------------------------------------------------------

BIT_AT(PIE1_ADDR,6)	ADIE;
BIT_AT(PIE1_ADDR,2)	CCP1IE;
BIT_AT(PIE1_ADDR,1)	TMR2IE;
BIT_AT(PIE1_ADDR,0)	TMR1IE;

//----- PCON Bits ----------------------------------------------------------

BIT_AT(PCON_ADDR,1)	NOT_POR;
BIT_AT(PCON_ADDR,0)	NOT_BO;
BIT_AT(PCON_ADDR,0)	NOT_BOD;

//----- ADCON1 Bits --------------------------------------------------------

BIT_AT(ADCON1_ADDR,2)	PCFG2;
BIT_AT(ADCON1_ADDR,1)	PCFG1;
BIT_AT(ADCON1_ADDR,0)	PCFG0;

//==========================================================================
//
//       RAM Definition
//
//==========================================================================

//         __MAXRAM H'BF'
//         __BADRAM H'08'-H'09', H'0D', H'13'-H'14', H'18'-H'1D'
//         __BADRAM H'88'-H'89', H'8D', H'8F'-H'91', H'93'-H'9E'

//==========================================================================
//
//       Configuration Bits
//
//==========================================================================

#define _BODEN_ON            0x3FFF
#define _BODEN_OFF           0x3FBF
#define _CP_ALL              0x00CF
#define _CP_75               0x15DF
#define _CP_50               0x2AEF
#define _CP_OFF              0x3FFF
#define _PWRTE_OFF           0x3FFF
#define _PWRTE_ON            0x3FF7
#define _WDT_ON              0x3FFF
#define _WDT_OFF             0x3FFB
#define _LP_OSC              0x3FFC
#define _XT_OSC              0x3FFD
#define _HS_OSC              0x3FFE
#define _RC_OSC              0x3FFF

//         LIST
#endif
