//
// Register Declarations for Microchip 16HV540 Processor
//
//
// This header file was automatically generated by:
//
//	inc2h.pl V1.4
//
//	Copyright (c) 2002, Kevin L. Pauba, All Rights Reserved
//
//	SDCC is licensed under the GNU Public license (GPL) v2.  Note that
//	this license covers the code to the compiler and other executables,
//	but explicitly does not cover any code or objects generated by sdcc.
//	We have not yet decided on a license for the run time libraries, but
//	it will not put any requirements on code linked against it. See:
// 
//	http://www.gnu.org/copyleft/gpl/html
//
//	See http://sdcc.sourceforge.net/ for the latest information on sdcc.
//
// 
#ifndef P16HV540_H
#define P16HV540_H

#ifndef BIT_AT
#define BIT_AT(base,bitno) sbit at ((base<<3)+bitno)
#endif

//
// Register addresses.
//
#define INDF_ADDR	0x0000
#define TMR0_ADDR	0x0001
#define PCL_ADDR	0x0002
#define STATUS_ADDR	0x0003
#define FSR_ADDR	0x0004
#define PORTA_ADDR	0x0005
#define PORTB_ADDR	0x0006

//
// Memory organization.
//
#pragma maxram 0x01F


#pragma memmap INDF_ADDR INDF_ADDR SFR 0x000	// INDF
#pragma memmap TMR0_ADDR TMR0_ADDR SFR 0x000	// TMR0
#pragma memmap PCL_ADDR PCL_ADDR SFR 0x000	// PCL
#pragma memmap STATUS_ADDR STATUS_ADDR SFR 0x000	// STATUS
#pragma memmap FSR_ADDR FSR_ADDR SFR 0x000	// FSR
#pragma memmap PORTA_ADDR PORTA_ADDR SFR 0x000	// PORTA
#pragma memmap PORTB_ADDR PORTB_ADDR SFR 0x000	// PORTB


// 	LIST
// P16HV540.INC  Standard Header File, Version 4.00    Microchip Technology, Inc.
// 	NOLIST

// This header file defines configurations, registers, and other useful bits of
// information for the 16HV540 microcontroller.  These names are taken to match 
// the data sheets as closely as possible.
// There is one group of symbols that is valid for all microcontrollers.  
// Each microcontroller in this family also has its own section of special 
// symbols.  Note that the processor must be selected before this file is 
// included.  The processor may be selected the following ways:

//       1. Command line switch:
//               C:\ MPASM MYFILE.ASM /P16HV540
//       2. LIST directive in the source file
//               LIST   P=16HV540
//       3. Processor Type entry in the MPASM full-screen interface

//==========================================================================
//
//	   Revision History
//
//==========================================================================

//Rev:   Date:   Reason:

//1.00	10 Feb 1999  initial release.

//==========================================================================
//
//       Generic Definitions
//
//==========================================================================

#define W                    0x0000
#define F                    0x0001

//----- Register Files -----------------------------------------------------

data at INDF_ADDR volatile char        INDF;
sfr  at TMR0_ADDR                      TMR0;
data at PCL_ADDR volatile char         PCL;
sfr  at STATUS_ADDR                    STATUS;
sfr  at FSR_ADDR                       FSR;
sfr  at PORTA_ADDR                     PORTA;
sfr  at PORTB_ADDR                     PORTB;

//----- STATUS Bits --------------------------------------------------------

BIT_AT(STATUS_ADDR,7)	PCF;
BIT_AT(STATUS_ADDR,6)	PA1;
BIT_AT(STATUS_ADDR,5)	PA0;
BIT_AT(STATUS_ADDR,4)	NOT_TO;
BIT_AT(STATUS_ADDR,3)	NOT_PD;
BIT_AT(STATUS_ADDR,2)	Z;
BIT_AT(STATUS_ADDR,1)	DC;
BIT_AT(STATUS_ADDR,0)	C;

//----- OPTION Bits --------------------------------------------------------

BIT_AT(OPTION_REG_ADDR,5)	T0CS;
BIT_AT(OPTION_REG_ADDR,4)	T0SE;
BIT_AT(OPTION_REG_ADDR,3)	PSA;
BIT_AT(OPTION_REG_ADDR,2)	PS2;
BIT_AT(OPTION_REG_ADDR,1)	PS1;
BIT_AT(OPTION_REG_ADDR,0)	PS0;

//----- OPTION2 Bits --------------------------------------------------------

BIT_AT(OPTION2_ADDR,5)	WPC;
BIT_AT(OPTION2_ADDR,4)	SWE;
BIT_AT(OPTION2_ADDR,3)	RL;
BIT_AT(OPTION2_ADDR,2)	SL;
BIT_AT(OPTION2_ADDR,1)	BL;
BIT_AT(OPTION2_ADDR,0)	BE;


//            __MAXRAM H'01F'


//==========================================================================
//
//       Configuration Bits
//
//==========================================================================

#define _CP_ON               0x0FF7
#define _CP_OFF              0x0FFF
#define _WDT_ON              0x0FFF
#define _WDT_OFF             0x0FFB
#define _LP_OSC              0x0FFC
#define _XT_OSC              0x0FFD
#define _HS_OSC              0x0FFE
#define _RC_OSC              0x0FFF

// 	LIST
#endif
