//
// Register Declarations for Microchip 17C42 Processor
//
//
// This header file was automatically generated by:
//
//	inc2h.pl V1.4
//
//	Copyright (c) 2002, Kevin L. Pauba, All Rights Reserved
//
//	SDCC is licensed under the GNU Public license (GPL) v2.  Note that
//	this license covers the code to the compiler and other executables,
//	but explicitly does not cover any code or objects generated by sdcc.
//	We have not yet decided on a license for the run time libraries, but
//	it will not put any requirements on code linked against it. See:
// 
//	http://www.gnu.org/copyleft/gpl/html
//
//	See http://sdcc.sourceforge.net/ for the latest information on sdcc.
//
// 
#ifndef P17C42_H
#define P17C42_H

#ifndef BIT_AT
#define BIT_AT(base,bitno) sbit at ((base<<3)+bitno)
#endif

//
// Register addresses.
//
#define INDF0_ADDR	0x0000
#define FSR0_ADDR	0x0001
#define PCL_ADDR	0x0002
#define PCLATH_ADDR	0x0003
#define ALUSTA_ADDR	0x0004
#define T0STA_ADDR	0x0005
#define CPUSTA_ADDR	0x0006
#define INTSTA_ADDR	0x0007
#define INDF1_ADDR	0x0008
#define FSR1_ADDR	0x0009
#define WREG_ADDR	0x000A
#define TMR0L_ADDR	0x000B
#define TMR0H_ADDR	0x000C
#define TBLPTRL_ADDR	0x000D
#define TBLPTRH_ADDR	0x000E
#define BSR_ADDR	0x000F
#define PORTA_ADDR	0x0010
#define DDRB_ADDR	0x0011
#define PORTB_ADDR	0x0012
#define RCSTA_ADDR	0x0013
#define RCREG_ADDR	0x0014
#define TXSTA_ADDR	0x0015
#define TXREG_ADDR	0x0016
#define SPBRG_ADDR	0x0017

//
// Memory organization.
//
#pragma maxram 0x3FF


#pragma memmap INDF0_ADDR INDF0_ADDR SFR 0x000	// INDF0
#pragma memmap FSR0_ADDR FSR0_ADDR SFR 0x000	// FSR0
#pragma memmap PCL_ADDR PCL_ADDR SFR 0x000	// PCL
#pragma memmap PCLATH_ADDR PCLATH_ADDR SFR 0x000	// PCLATH
#pragma memmap ALUSTA_ADDR ALUSTA_ADDR SFR 0x000	// ALUSTA
#pragma memmap T0STA_ADDR T0STA_ADDR SFR 0x000	// T0STA
#pragma memmap CPUSTA_ADDR CPUSTA_ADDR SFR 0x000	// CPUSTA
#pragma memmap INTSTA_ADDR INTSTA_ADDR SFR 0x000	// INTSTA
#pragma memmap INDF1_ADDR INDF1_ADDR SFR 0x000	// INDF1
#pragma memmap FSR1_ADDR FSR1_ADDR SFR 0x000	// FSR1
#pragma memmap WREG_ADDR WREG_ADDR SFR 0x000	// WREG
#pragma memmap TMR0L_ADDR TMR0L_ADDR SFR 0x000	// TMR0L
#pragma memmap TMR0H_ADDR TMR0H_ADDR SFR 0x000	// TMR0H
#pragma memmap TBLPTRL_ADDR TBLPTRL_ADDR SFR 0x000	// TBLPTRL
#pragma memmap TBLPTRH_ADDR TBLPTRH_ADDR SFR 0x000	// TBLPTRH
#pragma memmap BSR_ADDR BSR_ADDR SFR 0x000	// BSR
#pragma memmap PORTA_ADDR PORTA_ADDR SFR 0x000	// PORTA
#pragma memmap DDRB_ADDR DDRB_ADDR SFR 0x000	// DDRB
#pragma memmap PORTB_ADDR PORTB_ADDR SFR 0x000	// PORTB
#pragma memmap RCSTA_ADDR RCSTA_ADDR SFR 0x000	// RCSTA
#pragma memmap RCREG_ADDR RCREG_ADDR SFR 0x000	// RCREG
#pragma memmap TXSTA_ADDR TXSTA_ADDR SFR 0x000	// TXSTA
#pragma memmap TXREG_ADDR TXREG_ADDR SFR 0x000	// TXREG
#pragma memmap SPBRG_ADDR SPBRG_ADDR SFR 0x000	// SPBRG


//         LIST
// P17C42.INC  Standard Header File, Version 1.03    Microchip Technology, Inc.
//         NOLIST

// This header file defines configurations, registers, and other useful bits of
// information for the PIC17C42 microcontroller.  These names are taken to match 
// the data sheets as closely as possible.  

// Note that the processor must be selected before this file is 
// included.  The processor may be selected the following ways:

//       1. Command line switch:
//               C:\ MPASM MYFILE.ASM /PIC17C42
//       2. LIST directive in the source file
//               LIST   P=PIC17C42
//       3. Processor Type entry in the MPASM full-screen interface

//==========================================================================
//
//       Revision History
//
//==========================================================================

//Rev:   Date:    Reason:

//1.03   07/15/96 Corrected MAXRAM
//1.02   06/28/96 Corrected MAXRAM, BADRAM, and registers in upper banks
//1.01   04/10/96 Added _WDT_OFF value, PSx values
//1.00   10/31/95 Initial Release

//==========================================================================
//
//       Verify Processor
//
//==========================================================================

//        IFNDEF __17C42
//            MESSG "Processor-header file mismatch.  Verify selected processor."
//         ENDIF

//==========================================================================
//
//       Register Definitions
//
//==========================================================================

#define W                    0x0000
#define F                    0x0001

#define BANK0                0x0000
#define BANK1                0x0001
#define BANK2                0x0002
#define BANK3                0x0003

//----- Register Files -----------------------------------------------------

sfr  at INDF0_ADDR                     INDF0;
sfr  at FSR0_ADDR                      FSR0;
data at PCL_ADDR volatile char         PCL;
sfr  at PCLATH_ADDR                    PCLATH;
sfr  at ALUSTA_ADDR                    ALUSTA;
sfr  at T0STA_ADDR                     T0STA;
sfr  at CPUSTA_ADDR                    CPUSTA;
sfr  at INTSTA_ADDR                    INTSTA;
sfr  at INDF1_ADDR                     INDF1;
sfr  at FSR1_ADDR                      FSR1;
sfr  at WREG_ADDR                      WREG;
sfr  at TMR0L_ADDR                     TMR0L;
sfr  at TMR0H_ADDR                     TMR0H;
sfr  at TBLPTRL_ADDR                   TBLPTRL;
sfr  at TBLPTRH_ADDR                   TBLPTRH;
sfr  at BSR_ADDR                       BSR;
sfr  at PORTA_ADDR                     PORTA;
sfr  at DDRB_ADDR                      DDRB;
sfr  at PORTB_ADDR                     PORTB;
sfr  at RCSTA_ADDR                     RCSTA;
sfr  at RCREG_ADDR                     RCREG;
sfr  at TXSTA_ADDR                     TXSTA;
sfr  at TXREG_ADDR                     TXREG;
sfr  at SPBRG_ADDR                     SPBRG;
// PRODL                           EQU     H'0018' ; not on the 17C42
// PRODH                           EQU     H'0019' ; not on the 17C42

#define DDRC                 0x0110
#define PORTC                0x0111
#define DDRD                 0x0112
#define PORTD                0x0113
#define DDRE                 0x0114
#define PORTE                0x0115
#define PIR                  0x0116
#define PIE                  0x0117

#define TMR1                 0x0210
#define TMR2                 0x0211
#define TMR3L                0x0212
#define TMR3H                0x0213
#define PR1                  0x0214
#define PR2                  0x0215
#define PR3L                 0x0216
#define PR3H                 0x0217

#define CA1L                 0x0216
#define CA1H                 0x0217

#define PW1DCL               0x0310
#define PW2DCL               0x0311
#define PW1DCH               0x0312
#define PW2DCH               0x0313
#define CA2L                 0x0314
#define CA2H                 0x0315
#define TCON1                0x0316
#define TCON2                0x0317

//----- ALUSTA Bits --------------------------------------------------------

BIT_AT(ALUSTA_ADDR,7)	FS3;
BIT_AT(ALUSTA_ADDR,6)	FS2;
BIT_AT(ALUSTA_ADDR,5)	FS1;
BIT_AT(ALUSTA_ADDR,4)	FS0;
BIT_AT(ALUSTA_ADDR,3)	OV;
BIT_AT(ALUSTA_ADDR,2)	Z;
BIT_AT(ALUSTA_ADDR,1)	DC;
BIT_AT(ALUSTA_ADDR,0)	C;

//----- CPUSTA Bits --------------------------------------------------------

BIT_AT(CPUSTA_ADDR,5)	STKAV;
BIT_AT(CPUSTA_ADDR,4)	GLINTD;
BIT_AT(CPUSTA_ADDR,3)	NOT_TO;
BIT_AT(CPUSTA_ADDR,2)	NOT_PD;

//----- INTSTA Bits --------------------------------------------------------

BIT_AT(INTSTA_ADDR,7)	PEIF;
BIT_AT(INTSTA_ADDR,6)	T0CKIF;
BIT_AT(INTSTA_ADDR,5)	T0IF;
BIT_AT(INTSTA_ADDR,4)	INTF;
BIT_AT(INTSTA_ADDR,3)	PEIE;
BIT_AT(INTSTA_ADDR,2)	T0CKIE;
BIT_AT(INTSTA_ADDR,1)	T0IE;
BIT_AT(INTSTA_ADDR,0)	INTE;

//----- PIE Bits -----------------------------------------------------------

BIT_AT(PIE_ADDR,7)	RBIE;
BIT_AT(PIE_ADDR,6)	TMR3IE;
BIT_AT(PIE_ADDR,5)	TMR2IE;
BIT_AT(PIE_ADDR,4)	TMR1IE;
BIT_AT(PIE_ADDR,3)	CA2IE;
BIT_AT(PIE_ADDR,2)	CA1IE;
BIT_AT(PIE_ADDR,1)	TXIE;
BIT_AT(PIE_ADDR,0)	RCIE;

//----- PIR Bits -----------------------------------------------------------

BIT_AT(PIR_ADDR,7)	RBIF;
BIT_AT(PIR_ADDR,6)	TMR3IF;
BIT_AT(PIR_ADDR,5)	TMR2IF;
BIT_AT(PIR_ADDR,4)	TMR1IF;
BIT_AT(PIR_ADDR,3)	CA2IF;
BIT_AT(PIR_ADDR,2)	CA1IF;
BIT_AT(PIR_ADDR,1)	TXIF;
BIT_AT(PIR_ADDR,0)	RCIF;

//----- PORTA Bits ---------------------------------------------------------

BIT_AT(PORTA_ADDR,7)	NOT_RBPU;
BIT_AT(PORTA_ADDR,1)	T0CKI;
BIT_AT(PORTA_ADDR,0)	INT;

//----- RCSTA Bits ---------------------------------------------------------

BIT_AT(RCSTA_ADDR,7)	SPEN;
BIT_AT(RCSTA_ADDR,6)	RX9;
BIT_AT(RCSTA_ADDR,6)	RC9;    // Backward compatibility only
BIT_AT(RCSTA_ADDR,6)	NOT_RC8;    // Backward compatibility only
BIT_AT(RCSTA_ADDR,6)	RC8_9;    // Backward compatibility only
BIT_AT(RCSTA_ADDR,5)	SREN;
BIT_AT(RCSTA_ADDR,4)	CREN;
BIT_AT(RCSTA_ADDR,2)	FERR;
BIT_AT(RCSTA_ADDR,1)	OERR;
BIT_AT(RCSTA_ADDR,0)	RX9D;
BIT_AT(RCSTA_ADDR,0)	RCD8;    // Backward compatibility only

//----- T0STA Bits --------------------------------------------------------

BIT_AT(T0STA_ADDR,7)	INTEDG;
BIT_AT(T0STA_ADDR,6)	T0SE;
BIT_AT(T0STA_ADDR,5)	T0CS;
BIT_AT(T0STA_ADDR,4)	T0PS3;
BIT_AT(T0STA_ADDR,4)	PS3;
BIT_AT(T0STA_ADDR,3)	T0PS2;
BIT_AT(T0STA_ADDR,3)	PS2;
BIT_AT(T0STA_ADDR,2)	T0PS1;
BIT_AT(T0STA_ADDR,2)	PS1;
BIT_AT(T0STA_ADDR,1)	T0PS0;
BIT_AT(T0STA_ADDR,1)	PS0;

//----- TCON1 Bits ---------------------------------------------------------

BIT_AT(TCON1_ADDR,7)	CA2ED1;
BIT_AT(TCON1_ADDR,6)	CA2ED0;
BIT_AT(TCON1_ADDR,5)	CA1ED1;
BIT_AT(TCON1_ADDR,4)	CA1ED0;
BIT_AT(TCON1_ADDR,3)	T16;
BIT_AT(TCON1_ADDR,2)	TMR3CS;
BIT_AT(TCON1_ADDR,1)	TMR2CS;
BIT_AT(TCON1_ADDR,0)	TMR1CS;

//----- TCON2 Bits ---------------------------------------------------------

BIT_AT(TCON2_ADDR,7)	CA2OVF;
BIT_AT(TCON2_ADDR,6)	CA1OVF;
BIT_AT(TCON2_ADDR,5)	PWM2ON;
BIT_AT(TCON2_ADDR,4)	PWM1ON;
BIT_AT(TCON2_ADDR,3)	CA1;
BIT_AT(TCON2_ADDR,3)	NOT_PR3;
BIT_AT(TCON2_ADDR,3)	CA1_PR3;
BIT_AT(TCON2_ADDR,2)	TMR3ON;
BIT_AT(TCON2_ADDR,1)	TMR2ON;
BIT_AT(TCON2_ADDR,0)	TMR1ON;

//----- TXSTA Bits ---------------------------------------------------------

BIT_AT(TXSTA_ADDR,7)	CSRC;
BIT_AT(TXSTA_ADDR,6)	TX9;
BIT_AT(TXSTA_ADDR,6)	NOT_TX8;    // Backward compatibility only
BIT_AT(TXSTA_ADDR,6)	TX8_9;    // Backward compatibility only
BIT_AT(TXSTA_ADDR,5)	TXEN;
BIT_AT(TXSTA_ADDR,4)	SYNC;
BIT_AT(TXSTA_ADDR,1)	TRMT;
BIT_AT(TXSTA_ADDR,0)	TX9D;
BIT_AT(TXSTA_ADDR,0)	TXD8;    // Backward compatibility only

//==========================================================================
//
//       RAM Definition
//
//==========================================================================

//         __MAXRAM        H'3FF'
//         __BADRAM        H'118'-H'1FF', H'218'-H'2FF', H'318'-H'3FF'

//==========================================================================
//
//       Configuration Bits
//
//==========================================================================

#define _PMC_MODE            0xFFAF
#define _XMC_MODE            0xFFBF
#define _MC_MODE             0xFFEF
#define _MP_MODE             0xFFFF
#define _WDT_NORM            0xFFF3
#define _WDT_OFF             0xFFF3
#define _WDT_64              0xFFF7
#define _WDT_256             0xFFFB
#define _WDT_1               0xFFFF
#define _LF_OSC              0xFFFC
#define _RC_OSC              0xFFFD
#define _XT_OSC              0xFFFE
#define _EC_OSC              0xFFFF

//         LIST
#endif
