//
// Register Declarations for Microchip 17C766 Processor
//
//
// This header file was automatically generated by:
//
//	inc2h.pl V1.4
//
//	Copyright (c) 2002, Kevin L. Pauba, All Rights Reserved
//
//	SDCC is licensed under the GNU Public license (GPL) v2.  Note that
//	this license covers the code to the compiler and other executables,
//	but explicitly does not cover any code or objects generated by sdcc.
//	We have not yet decided on a license for the run time libraries, but
//	it will not put any requirements on code linked against it. See:
// 
//	http://www.gnu.org/copyleft/gpl/html
//
//	See http://sdcc.sourceforge.net/ for the latest information on sdcc.
//
// 
#ifndef P17C766_H
#define P17C766_H

#ifndef BIT_AT
#define BIT_AT(base,bitno) sbit at ((base<<3)+bitno)
#endif

//
// Register addresses.
//
#define INDF0_ADDR	0x0000
#define FSR0_ADDR	0x0001
#define PCL_ADDR	0x0002
#define PCLATH_ADDR	0x0003
#define ALUSTA_ADDR	0x0004
#define T0STA_ADDR	0x0005
#define CPUSTA_ADDR	0x0006
#define INTSTA_ADDR	0x0007
#define INDF1_ADDR	0x0008
#define FSR1_ADDR	0x0009
#define WREG_ADDR	0x000A
#define TMR0L_ADDR	0x000B
#define TMR0H_ADDR	0x000C
#define TBLPTRL_ADDR	0x000D
#define TBLPTRH_ADDR	0x000E
#define BSR_ADDR	0x000F

//
// Memory organization.
//
#pragma maxram 0x8FF


#pragma memmap INDF0_ADDR INDF0_ADDR SFR 0x000	// INDF0
#pragma memmap FSR0_ADDR FSR0_ADDR SFR 0x000	// FSR0
#pragma memmap PCL_ADDR PCL_ADDR SFR 0x000	// PCL
#pragma memmap PCLATH_ADDR PCLATH_ADDR SFR 0x000	// PCLATH
#pragma memmap ALUSTA_ADDR ALUSTA_ADDR SFR 0x000	// ALUSTA
#pragma memmap T0STA_ADDR T0STA_ADDR SFR 0x000	// T0STA
#pragma memmap CPUSTA_ADDR CPUSTA_ADDR SFR 0x000	// CPUSTA
#pragma memmap INTSTA_ADDR INTSTA_ADDR SFR 0x000	// INTSTA
#pragma memmap INDF1_ADDR INDF1_ADDR SFR 0x000	// INDF1
#pragma memmap FSR1_ADDR FSR1_ADDR SFR 0x000	// FSR1
#pragma memmap WREG_ADDR WREG_ADDR SFR 0x000	// WREG
#pragma memmap TMR0L_ADDR TMR0L_ADDR SFR 0x000	// TMR0L
#pragma memmap TMR0H_ADDR TMR0H_ADDR SFR 0x000	// TMR0H
#pragma memmap TBLPTRL_ADDR TBLPTRL_ADDR SFR 0x000	// TBLPTRL
#pragma memmap TBLPTRH_ADDR TBLPTRH_ADDR SFR 0x000	// TBLPTRH
#pragma memmap BSR_ADDR BSR_ADDR SFR 0x000	// BSR


//         LIST
// P17C766.INC  Standard Header File, Version 1.0   Microchip Technology, Inc.
//         NOLIST

// This header file defines configurations, registers, and other useful bits of
// information for the PIC17C766 microcontroller.  These names are taken to match 
// the data sheets as closely as possible.  

// Note that the processor must be selected before this file is 
// included.  The processor may be selected the following ways:

//       1. Command line switch:
//               C:\ MPASM MYFILE.ASM /PIC17C766
//       2. LIST directive in the source file
//               LIST   P=PIC17C766
//       3. Processor Type entry in the MPASM full-screen interface

//==========================================================================
//
//       Revision History
//
//==========================================================================

//Rev:   Date:    Reason:

//1.00   05/01/98 Initial Release

//==========================================================================
//
//       Verify Processor
//
//==========================================================================

//        IFNDEF __17C766
//            MESSG "Processor-header file mismatch.  Verify selected processor."
//         ENDIF

//==========================================================================
//
//       Register Definitions
//
//==========================================================================

#define W                    0x0000
#define F                    0x0001

#define BANK0                0x0000
#define BANK1                0x0001
#define BANK2                0x0002
#define BANK3                0x0003
#define BANK4                0x0004
#define BANK5                0x0005
#define BANK6                0x0006
#define BANK7                0x0007
#define BANK8                0x0008	// added 5/2/01 BD - Apps

#define GPR_BANK0            0x0000
#define GPR_BANK1            0x0008
#define GPR_BANK2            0x0010
#define GPR_BANK3            0x0018

//----- Register Files -----------------------------------------------------

sfr  at INDF0_ADDR                     INDF0;
sfr  at FSR0_ADDR                      FSR0;
data at PCL_ADDR volatile char         PCL;
sfr  at PCLATH_ADDR                    PCLATH;
sfr  at ALUSTA_ADDR                    ALUSTA;
sfr  at T0STA_ADDR                     T0STA;
sfr  at CPUSTA_ADDR                    CPUSTA;
sfr  at INTSTA_ADDR                    INTSTA;
sfr  at INDF1_ADDR                     INDF1;
sfr  at FSR1_ADDR                      FSR1;
sfr  at WREG_ADDR                      WREG;
sfr  at TMR0L_ADDR                     TMR0L;
sfr  at TMR0H_ADDR                     TMR0H;
sfr  at TBLPTRL_ADDR                   TBLPTRL;
sfr  at TBLPTRH_ADDR                   TBLPTRH;
sfr  at BSR_ADDR                       BSR;

//----- Bank 0 -------------------------------------------------------------

#define PORTA                0x0010
#define DDRB                 0x0011
#define PORTB                0x0012
#define RCSTA                0x0013
#define RCSTA1               0x0013
#define RCREG                0x0014    // Backward compatibility only
#define RCREG1               0x0014
#define TXSTA                0x0015    // Backward compatibility only
#define TXSTA1               0x0015
#define TXREG                0x0016    // Backward compatibility only
#define TXREG1               0x0016
#define SPBRG                0x0017    // Backward compatibility only
#define SPBRG1               0x0017

//----- Bank 1 -------------------------------------------------------------

#define DDRC                 0x0110
#define PORTC                0x0111
#define DDRD                 0x0112
#define PORTD                0x0113
#define DDRE                 0x0114
#define PORTE                0x0115
#define PIR                  0x0116    // Backward compatibility only
#define PIR1                 0x0116
#define PIE                  0x0117    // Backward compatibility only
#define PIE1                 0x0117

//----- Bank 2 -------------------------------------------------------------

#define TMR1                 0x0210
#define TMR2                 0x0211
#define TMR3L                0x0212
#define TMR3H                0x0213
#define PR1                  0x0214
#define PR2                  0x0215
#define PR3L                 0x0216
#define PR3H                 0x0217

#define CA1L                 0x0216
#define CA1H                 0x0217

//----- Bank 3 -------------------------------------------------------------

#define PW1DCL               0x0310
#define PW2DCL               0x0311
#define PW1DCH               0x0312
#define PW2DCH               0x0313
#define CA2L                 0x0314
#define CA2H                 0x0315
#define TCON1                0x0316
#define TCON2                0x0317

//----- Bank 4 -------------------------------------------------------------

#define PIR2                 0x0410
#define PIE2                 0x0411

#define RCSTA2               0x0413
#define RCREG2               0x0414
#define TXSTA2               0x0415
#define TXREG2               0x0416
#define SPBRG2               0x0417

//----- Bank 5 -------------------------------------------------------------

#define DDRF                 0x0510
#define PORTF                0x0511
#define DDRG                 0x0512
#define PORTG                0x0513
#define ADCON0               0x0514
#define ADCON1               0x0515
#define ADRESL               0x0516
#define ADRESH               0x0517

//----- Bank 6 -------------------------------------------------------------

#define SSPADD               0x0610
#define SSPCON1              0x0611
#define SSPCON2              0x0612
#define SSPSTAT              0x0613
#define SSPBUF               0x0614

//----- Bank 7 -------------------------------------------------------------

#define PW3DCL               0x0710
#define PW3DCH               0x0711
#define CA3L                 0x0712
#define CA3H                 0x0713
#define CA4L                 0x0714
#define CA4H                 0x0715
#define TCON3                0x0716

//----- Bank 8 -------------------------------------------------------------

#define DDRH                 0x0810
#define PORTH                0x0811
#define DDRJ                 0x0812
#define PORTJ                0x0813


//----- Unbanked -----------------------------------------------------------

#define PRODL                0x0018
#define PL                   0x0018    // Backward compatibility only
#define PRODH                0x0019
#define PH                   0x0019    // Backward compatibility only

//----- Special Function Register Bit Definitions --------------------------
//
//----- ALUSTA Bits --------------------------------------------------------

BIT_AT(ALUSTA_ADDR,7)	FS3;
BIT_AT(ALUSTA_ADDR,6)	FS2;
BIT_AT(ALUSTA_ADDR,5)	FS1;
BIT_AT(ALUSTA_ADDR,4)	FS0;
BIT_AT(ALUSTA_ADDR,3)	OV;
BIT_AT(ALUSTA_ADDR,2)	Z;
BIT_AT(ALUSTA_ADDR,1)	DC;
BIT_AT(ALUSTA_ADDR,0)	C;

//----- CPUSTA Bits --------------------------------------------------------

BIT_AT(CPUSTA_ADDR,5)	STKAV;
BIT_AT(CPUSTA_ADDR,4)	GLINTD;
BIT_AT(CPUSTA_ADDR,3)	NOT_TO;
BIT_AT(CPUSTA_ADDR,3)	TO;
BIT_AT(CPUSTA_ADDR,2)	NOT_PD;
BIT_AT(CPUSTA_ADDR,2)	PD;
BIT_AT(CPUSTA_ADDR,1)	NOT_POR;
BIT_AT(CPUSTA_ADDR,1)	POR;
BIT_AT(CPUSTA_ADDR,0)	NOT_BOR;
BIT_AT(CPUSTA_ADDR,0)	BOR;

//----- INTSTA Bits --------------------------------------------------------

BIT_AT(INTSTA_ADDR,7)	PEIF;
BIT_AT(INTSTA_ADDR,6)	T0CKIF;
BIT_AT(INTSTA_ADDR,5)	T0IF;
BIT_AT(INTSTA_ADDR,4)	INTF;
BIT_AT(INTSTA_ADDR,3)	PEIE;
BIT_AT(INTSTA_ADDR,2)	T0CKIE;
BIT_AT(INTSTA_ADDR,1)	T0IE;
BIT_AT(INTSTA_ADDR,0)	INTE;

//----- PIR1 Bits ----------------------------------------------------------

BIT_AT(PIR1_ADDR,7)	RBIF;
BIT_AT(PIR1_ADDR,6)	TMR3IF;
BIT_AT(PIR1_ADDR,5)	TMR2IF;
BIT_AT(PIR1_ADDR,4)	TMR1IF;
BIT_AT(PIR1_ADDR,3)	CA2IF;
BIT_AT(PIR1_ADDR,2)	CA1IF;
BIT_AT(PIR1_ADDR,1)	TXIF;    // Backward compatibility only
BIT_AT(PIR1_ADDR,1)	TX1IF;
BIT_AT(PIR1_ADDR,0)	RCIF;    // Backward compatibility only
BIT_AT(PIR1_ADDR,0)	RC1IF;

//----- PIE1 Bits -----------------------------------------------------------

BIT_AT(PIE1_ADDR,7)	RBIE;
BIT_AT(PIE1_ADDR,6)	TMR3IE;
BIT_AT(PIE1_ADDR,5)	TMR2IE;
BIT_AT(PIE1_ADDR,4)	TMR1IE;
BIT_AT(PIE1_ADDR,3)	CA2IE;
BIT_AT(PIE1_ADDR,2)	CA1IE;
BIT_AT(PIE1_ADDR,1)	TXIE;    // Backward compatibility only
BIT_AT(PIE1_ADDR,1)	TX1IE;
BIT_AT(PIE1_ADDR,0)	RCIE;    // Backward compatibility only
BIT_AT(PIE1_ADDR,0)	RC1IE;

//----- PORTA Bits ---------------------------------------------------------

BIT_AT(PORTA_ADDR,7)	NOT_RBPU;
BIT_AT(PORTA_ADDR,7)	RBPU;

//----- RCSTA1 and 2 Bits --------------------------------------------------

#define SPEN                 0x0007
#define RX9                  0x0006
#define RC9                  0x0006    // Backward compatibility only
#define NOT_RC8              0x0006    // Backward compatibility only
#define RC8_9                0x0006    // Backward compatibility only
#define SREN                 0x0005
#define CREN                 0x0004
#define FERR                 0x0002
#define OERR                 0x0001
#define RX9D                 0x0000
#define RCD8                 0x0000    // Backward compatibility only

//----- T0STA Bits --------------------------------------------------------

BIT_AT(T0STA_ADDR,7)	INTEDG;
BIT_AT(T0STA_ADDR,6)	T0SE;
BIT_AT(T0STA_ADDR,5)	T0CS;
BIT_AT(T0STA_ADDR,4)	T0PS3;
BIT_AT(T0STA_ADDR,4)	PS3;    // Backward compatibility only
BIT_AT(T0STA_ADDR,3)	T0PS2;
BIT_AT(T0STA_ADDR,3)	PS2;    // Backward compatibility only
BIT_AT(T0STA_ADDR,2)	T0PS1;
BIT_AT(T0STA_ADDR,2)	PS1;    // Backward compatibility only
BIT_AT(T0STA_ADDR,1)	T0PS0;
BIT_AT(T0STA_ADDR,1)	PS0;    // Backward compatibility only

//----- TCON1 Bits ---------------------------------------------------------

BIT_AT(TCON1_ADDR,7)	CA2ED1;
BIT_AT(TCON1_ADDR,6)	CA2ED0;
BIT_AT(TCON1_ADDR,5)	CA1ED1;
BIT_AT(TCON1_ADDR,4)	CA1ED0;
BIT_AT(TCON1_ADDR,3)	T16;
BIT_AT(TCON1_ADDR,2)	TMR3CS;
BIT_AT(TCON1_ADDR,1)	TMR2CS;
BIT_AT(TCON1_ADDR,0)	TMR1CS;

//----- TCON2 Bits ---------------------------------------------------------

BIT_AT(TCON2_ADDR,7)	CA2OVF;
BIT_AT(TCON2_ADDR,6)	CA1OVF;
BIT_AT(TCON2_ADDR,5)	PWM2ON;
BIT_AT(TCON2_ADDR,4)	PWM1ON;
BIT_AT(TCON2_ADDR,3)	CA1;
BIT_AT(TCON2_ADDR,3)	NOT_PR3;
BIT_AT(TCON2_ADDR,3)	PR3;
BIT_AT(TCON2_ADDR,3)	CA1_PR3;
BIT_AT(TCON2_ADDR,2)	TMR3ON;
BIT_AT(TCON2_ADDR,1)	TMR2ON;
BIT_AT(TCON2_ADDR,0)	TMR1ON;

//----- PIR2 Bits ----------------------------------------------------------

BIT_AT(PIR2_ADDR,7)	SSPIF;
BIT_AT(PIR2_ADDR,6)	BCLIF;
BIT_AT(PIR2_ADDR,5)	ADIF;
BIT_AT(PIR2_ADDR,3)	CA4IF;
BIT_AT(PIR2_ADDR,2)	CA3IF;
BIT_AT(PIR2_ADDR,1)	TX2IF;
BIT_AT(PIR2_ADDR,0)	RC2IF;

//----- PIE2 Bits ----------------------------------------------------------

BIT_AT(PIE2_ADDR,7)	SSPIE;
BIT_AT(PIE2_ADDR,6)	BCLIE;
BIT_AT(PIE2_ADDR,5)	ADIE;
BIT_AT(PIE2_ADDR,3)	CA4IE;
BIT_AT(PIE2_ADDR,2)	CA3IE;
BIT_AT(PIE2_ADDR,1)	TX2IE;
BIT_AT(PIE2_ADDR,0)	RC2IE;

//----- TXSTA1 and 2 Bits --------------------------------------------------

#define CSRC                 0x0007
#define TX9                  0x0006
#define NOT_TX8              0x0006    // Backward compatibility only
#define TX8_9                0x0006    // Backward compatibility only
#define TXEN                 0x0005
#define SYNC                 0x0004
#define TRMT                 0x0001
#define TX9D                 0x0000
#define TXD8                 0x0000    // Backward compatibility only

//----- ADCON0 Bits --------------------------------------------------------

BIT_AT(ADCON0_ADDR,7)	CHS3;
BIT_AT(ADCON0_ADDR,6)	CHS2;
BIT_AT(ADCON0_ADDR,5)	CHS1;
BIT_AT(ADCON0_ADDR,4)	CHS0;
BIT_AT(ADCON0_ADDR,2)	GO;
BIT_AT(ADCON0_ADDR,2)	NOT_DONE;
BIT_AT(ADCON0_ADDR,2)	DONE;
BIT_AT(ADCON0_ADDR,0)	ADON;

//----- ADCON1 Bits --------------------------------------------------------

BIT_AT(ADCON1_ADDR,7)	ADCS1;
BIT_AT(ADCON1_ADDR,6)	ADCS0;
BIT_AT(ADCON1_ADDR,5)	ADFM;
BIT_AT(ADCON1_ADDR,3)	PCFG3;
BIT_AT(ADCON1_ADDR,2)	PCFG2;
BIT_AT(ADCON1_ADDR,1)	PCFG1;
BIT_AT(ADCON1_ADDR,0)	PCFG0;

//----- SSPCON1 Bits -------------------------------------------------------

BIT_AT(SSPCON1_ADDR,7)	WCOL;
BIT_AT(SSPCON1_ADDR,6)	SSPOV;
BIT_AT(SSPCON1_ADDR,5)	SSPEN;
BIT_AT(SSPCON1_ADDR,4)	CKP;
BIT_AT(SSPCON1_ADDR,3)	SSPM3;
BIT_AT(SSPCON1_ADDR,2)	SSPM2;
BIT_AT(SSPCON1_ADDR,1)	SSPM1;
BIT_AT(SSPCON1_ADDR,0)	SSPM0;

//----- SSPCON2 Bits -------------------------------------------------------

BIT_AT(SSPCON2_ADDR,7)	GCEN;
BIT_AT(SSPCON2_ADDR,6)	ACKSTAT;
BIT_AT(SSPCON2_ADDR,6)	AKSTAT;
BIT_AT(SSPCON2_ADDR,5)	ACKDT;
BIT_AT(SSPCON2_ADDR,5)	AKDT;
BIT_AT(SSPCON2_ADDR,4)	ACKEN;
BIT_AT(SSPCON2_ADDR,4)	AKEN;
BIT_AT(SSPCON2_ADDR,3)	RCEN;
BIT_AT(SSPCON2_ADDR,2)	PEN;
BIT_AT(SSPCON2_ADDR,1)	RSEN;
BIT_AT(SSPCON2_ADDR,0)	SEN;

//----- SSPSTAT Bits -------------------------------------------------------

BIT_AT(SSPSTAT_ADDR,7)	SMP;
BIT_AT(SSPSTAT_ADDR,6)	CKE;
BIT_AT(SSPSTAT_ADDR,5)	D;
BIT_AT(SSPSTAT_ADDR,5)	NOT_A;
BIT_AT(SSPSTAT_ADDR,5)	D_A;
BIT_AT(SSPSTAT_ADDR,4)	P;
BIT_AT(SSPSTAT_ADDR,3)	S;
BIT_AT(SSPSTAT_ADDR,2)	R;
BIT_AT(SSPSTAT_ADDR,2)	NOT_W;
BIT_AT(SSPSTAT_ADDR,2)	R_W;
BIT_AT(SSPSTAT_ADDR,1)	UA;
BIT_AT(SSPSTAT_ADDR,0)	BF;

//----- TCON3 Bits ---------------------------------------------------------

BIT_AT(TCON3_ADDR,6)	CA4OVF;
BIT_AT(TCON3_ADDR,5)	CA3OVF;
BIT_AT(TCON3_ADDR,4)	CA4ED1;
BIT_AT(TCON3_ADDR,3)	CA4ED0;
BIT_AT(TCON3_ADDR,2)	CA3ED1;
BIT_AT(TCON3_ADDR,1)	CA3ED0;
BIT_AT(TCON3_ADDR,0)	PWM3ON;

//----- PW2DCL Bit ---------------------------------------------------------

#define TM2PW2               0x0005


//----- PW3DCL Bit ---------------------------------------------------------

#define TM2PW3               0x0005

//==========================================================================
//
//       RAM Definition
//
//==========================================================================

//         __MAXRAM        H'8FF'
//         __BADRAM        H'118'-H'11F', H'218'-H'21F', H'318'-H'31F'
//         __BADRAM        H'412', H'418'-H'4FF'
//         __BADRAM        H'518'-H'5FF'
//         __BADRAM        H'615'-H'6FF'
//         __BADRAM        H'717'-H'7FF'
//         __BADRAM        H'814'-H'8FF'

//==========================================================================
//
//       Configuration Bits
//
//==========================================================================

#define _PMC_MODE            0x7FAF
#define _XMC_MODE            0xFFBF
#define _MC_MODE             0xFFEF
#define _MP_MODE             0xFFFF

#define _BODEN_OFF           0xBFFF
#define _BODEN_ON            0xFFFF

#define _WDT_NORM            0xFFF3
#define _WDT_OFF             0xFFF3
#define _WDT_64              0xFFF7
#define _WDT_256             0xFFFB
#define _WDT_1               0xFFFF
#define _WDT_0               0xFFFF

#define _LF_OSC              0xFFFC
#define _RC_OSC              0xFFFD
#define _XT_OSC              0xFFFE
#define _EC_OSC              0xFFFF

//         LIST
#endif
